---
apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ template_file | basename | regex_replace('.tf.j2', '') | regex_replace('_', '-')}}
  namespace: {{ k8s_coder_namespace }}
data:
  configure.sh: |
    set -e
    export CODER_URL=http://coder.{{ k8s_coder_namespace }}.svc.{{ k8s_coder_cluster_domain }}
    export CODER_TEMPLATE_NAME={{ template_file | basename | regex_replace('.tf.j2', '') | regex_replace('_', '-')}}
    export CODER_TEMPLATE_DIR=.coder/templates/$CODER_TEMPLATE_NAME
    export CODER_TEMPLATE_VERSION="{{  ansible_date_time.date }}-{{  ansible_date_time.hour }}-{{  ansible_date_time.minute }}-{{  ansible_date_time.second }}"

    echo 'variables:'
    echo " - CODER_TEMPLATE_NAME: $CODER_TEMPLATE_NAME"
    echo " - CODER_TEMPLATE_DIR: $CODER_TEMPLATE_DIR"
    echo " - CODER_TEMPLATE_VERSION: $CODER_TEMPLATE_VERSION"
    
    echo '{{ k8s_coder_cli_auth }}' | coder login $CODER_URL
    echo "creating template dir: $CODER_TEMPLATE_DIR"
    mkdir -p $CODER_TEMPLATE_DIR
    echo "copying template into $CODER_TEMPLATE_DIR"
    cp /tmp/data/main.tf "$CODER_TEMPLATE_DIR/"
    echo 'existing templates (coder templates list)'
    coder templates list
    echo 'updating templates - coder templates push (creates if the template is not existing)'    mkdir -p templates
    coder templates push --yes --variable namespace={{ k8s_coder_namespace }} $CODER_TEMPLATE_NAME \
    --directory $CODER_TEMPLATE_DIR \
    --name=$CODER_TEMPLATE_VERSION

    # TODO: make these using variables
    # coder templates edit $CODER_TEMPLATE_NAME \
    # --display-name {{ template_file | basename | regex_replace('.tf.j2', '') | regex_replace('_', ' ')}} \
    # --description "Provision Kubernetes Deployments as Coder workspaces" \
    # --icon "/icon/k8s.png"

  main.tf: |    
{% filter indent(width=4) %}
    {% include template_file %}
{% endfilter %}

---
apiVersion: batch/v1
kind: Job
metadata:
  name: configure-{{ template_file | basename | regex_replace('.tf.j2', '') | regex_replace('_', '-')}}-template
  namespace: {{ k8s_coder_namespace }}
spec:
  ttlSecondsAfterFinished: 100
  template:
    spec:
      volumes:
      - name: config-volume
        configMap:
          name: {{ template_file | basename | regex_replace('.tf.j2', '') | regex_replace('_', '-')}}
          defaultMode: 0777
      containers:
      - image: ghcr.io/coder/coder:v{{ k8s_coder_helm_version }}
        name: configure
        command: 
        - sh
        args:
        - -c
        - "/tmp/data/configure.sh"
        volumeMounts:
        - name: config-volume
          mountPath: /tmp/data
      restartPolicy: Never
